<?php

/*
Plugin Name: Peter's Date Countdown
Plugin URI: http://www.theblog.ca
Description: Display a countdown of important dates
Version: 1.83
Author: Peter Keung
Author URI: http://www.theblog.ca/?p=41
Change Log:
2007-02-24  Fixed JavaScript countdown error (was counting all dates as if they were one month ahead)
2007-02-18  Added the option to customize the user level that can have access to manage countdowns
2007-02-10  Added the link option to the java countdown
2007-02-03  Added the option to use a java countdown, also an option to do reverse countdowns in the normal, php countdown version
2007-01-01  The phrase "x more sleeps" can now be customized to say days, winks, or anything else!
2006-11-03  You can now call a specific countdown by entering the number of the countdown in parentheses when calling the function.
2006-10-15  Hovering over a countdown item now shows date info.
2006-10-14  New option to add a link to the countdown item.  Also, consolidated path reference in the code.
2006-09-13  Plugin now uses the full php tags, thus you don't need to have short_open_tag enabled (if you don't know what this means, that's ok).
2006-09-01  New options where you can count down to the exact hour or minute when the time remaining is less than one day and also to limit the number of countdowns to show at once.
2006-08-26  New option to tweak the countdown time if your server time is different from your time
2006-08-14  New feature: sort the countdowns by date. Also, tweaked rounding of dates.
2006-08-10  The first version.
*/

// Change this if you want to add or subtract hours from your server time
$timediff = 0;

// Change this to equal "true" for java countdown mode. This overrides the following four settings, as it will automatically show hours and minutes, then will show negative numbers when the event has happened
// Also, it will always use the word "days" instead of something else like "sleeps"
$pdc_java = false;

// Change this to equal "true" if you want the countdown to display the number of hours remaining when there is less than one day remaining
$showhours = false;

// Change this to equal "true" if you want the countdown to display the number of minutes remaining when there is less than one hour remaining
$showminutes = false;

// Change this to equal "true" to show the time since an event has happened, instead of showing the "text when finished"
$pdc_showsince = false;

// Set this to the singular and plural form of what you want to display for "x more sleeps"
$pdc_sleep = "sleep";
$pdc_sleeps = "sleeps";

// Change this to equal the maximum number of countdowns to display at once. For an unlimited number of countdowns, make it equal 0
$numcountdowns = 0;

// Change this to be the path to the datecountdown folder in the plugins directory (should work as this by default)
$datecount_path = "wp-content/plugins/datecountdown/";

// This setting is to customize who has access to the Manage Countdowns page in the admin panel
// To allow only administrators access, set this to 9. A level of 7 will typically allow "editors" access as well
// See http://codex.wordpress.org/User_Levels for full documentation on the different user levels
$pdc_userlevel = 9;

// You shouldn't have to edit below this line!

function countdown_manage() {
global $timediff, $datecount_path;
if (isset($_GET['sort'])) {
require "../" . $datecount_path . "datecountdowndates.php";
$howmanydates = count($importantdate);
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
$month = $importantdate[$i][1] + 0;
$day = $importantdate[$i][2] + 0;
$year = $importantdate[$i][3] + 0;
$hour = $importantdate[$i][5] + 0;
$minute = $importantdate[$i][6] + 0;
$importantdate[$i]['date'] = mktime($hour,$minute,0,$month,$day,$year);
}
function cmp ($a, $b) {
if ( $a['date'] < $b['date'] ) {
return -1;
}
if ( $a['date'] > $b['date'] ) {
return 1;
}
return 0;
}
usort($importantdate, "cmp");
$line[] = "<?php";
$i = 0;
while ($i < $howmanydates) {
$itemname = $importantdate[$i][0];
$itemday = $importantdate[$i][2] + 0;
$itemmonth = $importantdate[$i][1] + 0;
$itemyear = $importantdate[$i][3] + 0;
$itemfinished = $importantdate[$i][4];
$itemhour = $importantdate[$i][5] + 0;
$itemminute = $importantdate[$i][6] + 0;
$itemlink = $importantdate[$i][7];
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute, \"$itemlink\");";
++$i;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../" . $datecount_path . "datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
if (isset($_GET['deletedate'])) {
$goback = $_SERVER['HTTP_REFERER'];
require "../" . $datecount_path . "datecountdowndates.php";
$line[] = "<?php";
$howmanydates = count($importantdate);
$modi = 0;
for ($i = 0; $i < $howmanydates; $i = $i + 1) {
if ($i == $_GET['deletedate']) {
continue;
}
$itemname = $importantdate[$i][0];
$itemmonth = $importantdate[$i][1] + 0;
$itemday = $importantdate[$i][2] + 0;
$itemyear = $importantdate[$i][3] + 0;
$itemfinished = $importantdate[$i][4];
$itemhour = $importantdate[$i][5] + 0;
$itemminute = $importantdate[$i][6] + 0;
$itemlink = $importantdate[$i][7];
$line[] = "$" . "importantdate[$modi]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute, \"$itemlink\");";
$modi = $modi + 1;
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../" . $datecount_path . "datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
print "<div class=\"wrap\">\n<p>Date deleted!</p>\n<p><a href=\"$goback\">Back</a><p>\n</div>";
}
else {
if ($_POST['submit']) {
$line[] = "<?php";
$howmanydates = count($_POST['itemname']);
$i = 0;
while ($i < $howmanydates) {
$itemname = $_POST['itemname'][$i];
$itemday = $_POST['itemday'][$i] + 0;
$itemmonth = $_POST['itemmonth'][$i] + 0;
$itemyear = $_POST['itemyear'][$i] + 0;
$itemfinished = $_POST['itemfinished'][$i];
$itemhour = $_POST['itemhour'][$i] + 0;
$itemminute = $_POST['itemminute'][$i] + 0;
$itemlink = $_POST['itemlink'][$i];
$line[] = "$" . "importantdate[$i]=array(\"$itemname\", $itemmonth, $itemday, $itemyear, \"$itemfinished\", $itemhour, $itemminute, \"$itemlink\");";
++$i;
if ($i + 1 == $howmanydates) {
if ($_POST['itemname'][$i] == "" or $_POST['itemday'][$i] == "" or $_POST['itemmonth'][$i] == "" or $_POST['itemyear'][$i] == "")
break;
}
}
$line[] = "?>";
$mystring = implode("\n", $line);
$open = fopen("../" . $datecount_path . "datecountdowndates.php", "w");
fwrite($open, $mystring);
fclose($open);
}
require "../" . $datecount_path . "datecountdowndates.php";
	?>
	<div class="wrap">
	<h2>Date Countdown</h2>
<h3>Current Countdowns:</h3>
<p><strong><a href="<?php print $_SERVER['PHP_SELF']; ?>?page=datecountdown.php&sort">Sort by date, ascending</a></strong></p>
<p><font color="red">Note: to delete an item, click on the red X, or simply replace the info with a new item!</font></p>
<form name="currentcountdowns" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?page=datecountdown.php">
<?php
$howmanydates = count($importantdate);
$i = 0;
while ($i < $howmanydates) {
?>
<p><strong><a href="<?php print $_SERVER['PHP_SELF']; ?>?page=datecountdown.php&deletedate=<?php print $i; ?>"><font color="red">X</font></a></strong>&nbsp;&nbsp;Name: <input type="text" name="<?php print "itemname[$i]"; ?>" size="30" maxlength="60" value="<?php print stripslashes($importantdate[$i][0]); ?>" /><br />Month: <input type="text" name="<?php print "itemmonth[$i]"; ?>" size="2" maxlength="2" value="<?php print $importantdate[$i][1]; ?>" /> Day: <input type="text" name="<?php print "itemday[$i]"; ?>" size="2" maxlength="2" value="<?php print $importantdate[$i][2]; ?>" /> Year: <input type="text" name="<?php print "itemyear[$i]"; ?>" size="4" maxlength="4" value="<?php print $importantdate[$i][3]; ?>" /> Hour (24hr): <input type="text" name="<?php print "itemhour[$i]"; ?>" size="2" maxlength="2" value="<?php print $importantdate[$i][5]; ?>" /> Minute: <input type="text" name="<?php print "itemminute[$i]"; ?>" size="2" maxlength="2" value="<?php print $importantdate[$i][6]; ?>" /><br />Text when finished: <input type="text" name="<?php print "itemfinished[$i]"; ?>" size="30" maxlength="60" value="<?php print stripslashes($importantdate[$i][4]); ?>" /><br />
Link to (leave blank for no link): <input type="text" name="<?php print "itemlink[$i]"; ?>" size="30" maxlength="60" value="<?php print $importantdate[$i][7]; ?>" /></p> 
	<?php
++$i;
}
?>
<h3>Add a new countdown</h3>
<p>Name: <input type="text" name="<?php print "itemname[$i]"; ?>" size="30" maxlength="60" /><br />Month: <input type="text" name="<?php print "itemmonth[$i]"; ?>" size="2" maxlength="2" /> Day: <input type="text" name="<?php print "itemday[$i]"; ?>" size="2" maxlength="2" /> Year: <input type="text" name="<?php print "itemyear[$i]"; ?>" size="4" maxlength="4" /> Hour (24hr): <input type="text" name="<?php print "itemhour[$i]"; ?>" size="2" maxlength="2" /> Minute: <input type="text" name="<?php print "itemminute[$i]"; ?>" size="2" maxlength="2" /><br />Text when finished: <input type="text" name="<?php print "itemfinished[$i]"; ?>" size="30" maxlength="60" /><br />
Link to (leave blank for no link): <input type="text" name="<?php print "itemlink[$i]"; ?>" size="30" maxlength="100" /></p>
<input name="submit" type="submit" value="Update" />
<?php
}
}

function countdown_callit($dateitem_select=false) {
global $timediff, $showhours, $showminutes, $numcountdowns, $datecount_path, $pdc_java;
// Determine the ABSPATH if it is not already defined (i.e., when called to generate the image) (thanks to Will Murray who implemented this piece of code on my custom anti-spam plugin)
if( ! defined( 'ABSPATH' ) )
{
	if (DIRECTORY_SEPARATOR=='/') {
		$abspath = dirname(__FILE__).'/';
	}
	else {
		$abspath = str_replace('\\', '/', dirname(__FILE__)).'/';
	}
	$absarray = explode( "/", $abspath );
	$abspath = "";
	foreach( $absarray as $value )
	{
		$abspath = $abspath . $value . "/";
		if( file_exists( $abspath . "wp-config.php" ) )
		{
			if( ! defined( 'ABSPATH' ) ) define( 'ABSPATH', $abspath, true );
		}
	}
}
if( ! defined( 'ABSPATH' ) ) die( "Could not determine the ABSPATH (the root of the blog)." );
require ABSPATH . $datecount_path . "datecountdowndates.php";

// show only a specific countdown item
if ($dateitem_select) {
$i = $dateitem_select - 1;

// check to see whether that specific countdown item exists
if ($dateitem_select > count($importantdate)) {
print "<p>That item number does not exist</p>";
}

// execute that specific countdown item
else {

// this is the java version
if ($pdc_java) {
print "<script language=\"javascript\" src=\"" . $datecount_path . "datecountdownjava.php\"></script>\n";
print "<p>\n";

$link = $importantdate[$i][7];
// show link if there is one
if ($link <> "") {
print "<a href=\"$link\">";
}

print "<script type=\"text/javascript\">\n";
print "countdown_clock({$importantdate[$i][3]}, {$importantdate[$i][1]} - 1, {$importantdate[$i][2]}, {$importantdate[$i][5]}, {$importantdate[$i][6]}, $i, $timediff);\n";
print "</script>\n";
$pdc_eventtext = $importantdate[$i][0];
print "until " . stripslashes($pdc_eventtext);

// close link if there is one
if ($link <> "") {
print "</a>";
}

print "</p>\n";
}

// this is the normal version
else {
countdown_execute(stripslashes($importantdate[$i][0]), $importantdate[$i][1], $importantdate[$i][2], $importantdate[$i][3], stripslashes($importantdate[$i][4]), $importantdate[$i][7], $timediff, $importantdate[$i][5], $importantdate[$i][6], $showhours, $showminutes);
}
}
}

// find out how many countdowns there are in total
else {
$howmanydates = count($importantdate);

// show a certain number of countdowns, if specified
if ($numcountdowns > 0 && $howmanydates > $numcountdowns) {
$howmanydates = $numcountdowns;
}
$i = 0;

// show the normal view of countdowns
if (!$pdc_java) {
while ($i < $howmanydates) {
countdown_execute(stripslashes($importantdate[$i][0]), $importantdate[$i][1], $importantdate[$i][2], $importantdate[$i][3], stripslashes($importantdate[$i][4]), $importantdate[$i][7], $timediff, $importantdate[$i][5], $importantdate[$i][6], $showhours, $showminutes);
++$i;
}
}

// show the java countdown
else {
print "<script language=\"javascript\" src=\"" . $datecount_path . "datecountdownjava.php\"></script>\n";
while ($i < $howmanydates) {
print "<p>\n";

$link = $importantdate[$i][7];
// show link if there is one
if ($link <> "") {
print "<a href=\"$link\">";
}

print "<script type=\"text/javascript\">\n";
print "countdown_clock({$importantdate[$i][3]}, {$importantdate[$i][1]} - 1, {$importantdate[$i][2]}, {$importantdate[$i][5]}, {$importantdate[$i][6]}, $i, $timediff);\n";
print "</script>\n";
$pdc_eventtext = $importantdate[$i][0];
print "until " . stripslashes($pdc_eventtext);

// close link if there is one
if ($link <> "") {
print "</a>";
}

print "</p>\n";
++$i;
}
}

}
}

function countdown_execute($event,$month,$day,$year,$finished,$link,$timediff,$hour,$minute,$showhours,$showminutes) {
global $pdc_sleep, $pdc_sleeps, $pdc_showsince;

// convert to a timestamp
$dc_timestamp=mktime($hour,$minute,0,$month,$day,$year);

// subtract desired date from current date and give an answer in terms of days
$remain = $dc_timestamp - (time() + $timediff * 3600);

// formulate the actual date to display when users hover over the item
$dc_datedisplay=date('l, M j, Y g:ia',$dc_timestamp);
$dc_gmtdiff=date('O')/100 + $timediff; 

// open the countdown item
print "<p><a ";

// display link if desired
if ($link <> "") {
print "href=\"$link\" ";
}

// display hover of actual date
print "title=\"$dc_datedisplay (GMT $dc_gmtdiff)\">";

// if the event has arrived, say so!
if ($remain < 0 && (!$pdc_showsince or $remain > -86400)) {
print "$finished";
}

// if set to be so, show the number of days since the event
elseif ($remain < 0 && $pdc_showsince) {
// make it a positive number of days
$remain = floor(($remain * -1) / 86400);
if ($remain == 1) {
print "<strong>$remain</strong> ";
_e("$pdc_sleep since");
print " $event";
}
else {
print "<strong>$remain</strong> ";
_e("$pdc_sleeps since");
print " $event";
}
}

// show the number of minutes remaining (if requested)
elseif ($remain < 3600 && $showminutes) {
$remain = ceil($remain / 60);
if ($remain == 1) {
print "<strong>$remain</strong> more minute until $event";
}
else {
print "<strong>$remain</strong> more minutes until $event";
}
}

// show the number of hours remaining (if requested)
elseif ($remain < 86400 && $showhours) {
if (!$showminutes) {
$remain = ceil($remain / 3600);
}
else {
$remain = round($remain / 3600);
}
if ($remain == 1) {
print "<strong>$remain</strong> more hour until $event";
}
else {
print "<strong>$remain</strong> more hours until $event";
}
}

// show the number of days remaining
else {
if (!$showhours) {
$remain = ceil($remain / 86400);
}
else {
$remain = round($remain / 86400);
}
if ($remain == 1) {
print "<strong>$remain</strong> ";
_e("more $pdc_sleep until");
print " $event";
}
else {
print "<strong>$remain</strong> ";
_e("more $pdc_sleeps until");
print " $event";
}
}

// close the countdown item
print "</a></p>\n";
}

function datecountdown_adminmenu(){
global $pdc_userlevel;
	add_management_page('Date Countdown', 'Date Countdown', $pdc_userlevel, 'datecountdown.php', 'countdown_manage');
}

add_action('admin_menu','datecountdown_adminmenu',1);
?>